#include <a_samp>
#include <martok>
#include <colors>
#include <dcmd>

#define STRING_ALREAD_DRIFTING 		"Du driftest bereits!"
#define STRING_DRIFT_BEGINS 		"Driftmode beginnt. /enddrift zum Beenden."
#define STRING_NOT_IN_DRIFT 		"Du driftest nicht!"
#define STRING_DRIFT_SCORED 		"Driftmode beendet. Du hast %d Punkte erzielt. Dein bester Drift war %d Punkte wert."
#define STRING_TOO_SLOW 			"Zu langsam!"
#define STRING_DRIFT_ONSCREEN 		"Drift: %d"
#define STRING_DRIFTEND_CAREXIT 	"Steig wieder in ein Auto und starte den Driftmode neu!"



#define INVALID_TIMER -1
#define TIMER_TIME    100

#define MIN_SPEED     20
#define MIN_ANGLE     20
#define MAX_ANGLE     140

#define abs(%1) floatabs(%1)



new vehicles[5];
enum t_driftinfo{
	bool:drifting,
	Float:lastx,Float:lasty,
	Float:lasthealth,
	Float:speed,
	Float:angle,
	score,
	scoretotal,
	scorebest,
	timer
}
new driftinfo[MAX_PLAYERS][t_driftinfo];

forward drifttimer(playerid);


public OnFilterScriptInit()
{
	print("--------------------------------------");
	print(" Drift mode by Martok");
	print("--------------------------------------");
	vehicles[0] = CreateVehicle(535,2351.8066,1415.5620,42.5849,88.7598,28,1, 1); // car1
	vehicles[1] = CreateVehicle(535,2351.4038,1422.9414,42.5825,91.6488,28,1, 1); // car2
	vehicles[2] = CreateVehicle(411,2351.8860,1430.0151,42.5799,90.6239,28,1, 1); // car3
	vehicles[3] = CreateVehicle(477,2351.9465,1436.9552,42.5821,91.5539,28,1, 1); // car4
	vehicles[4] = CreateVehicle(541,2351.7437,1444.1714,42.5799,89.0962,28,1, 1); // car5
	for (new i=0; i<MAX_PLAYERS; i++) {
	   if (IsPlayerConnected(i)) OnPlayerConnect(i);
	}
	return 1;
}

public OnFilterScriptExit()
{
	DestroyVehicle(vehicles[0]);
	DestroyVehicle(vehicles[1]);
	DestroyVehicle(vehicles[2]);
	DestroyVehicle(vehicles[3]);
	DestroyVehicle(vehicles[4]);
	return 1;
}

public OnVehicleSpawn(vehicleid)
{
	return 1;
}

public OnVehicleDeath(vehicleid, killerid)
{
	return 1;
}

dcmd_drift(playerid, params[])
{
	#pragma unused params
	if (driftinfo[playerid][timer]!=INVALID_TIMER) {
		SendClientMessage(playerid, COLOR_RED, STRING_ALREAD_DRIFTING);
		return 1;
	}
/*
	SetPlayerPos(playerid, 2345.4448,1388.9076,42.8203);
	SetPlayerFacingAngle(playerid, 90.0);
*/
	driftinfo[playerid][timer] = SetTimerEx("drifttimer",TIMER_TIME,true,"i",playerid);
	driftinfo[playerid][scoretotal] = 0;
	driftinfo[playerid][scorebest] = 0;
	if (IsPlayerInAnyVehicle(playerid)) InitDriftVehicle(playerid);
	SendClientMessage(playerid, COLOR_RED, STRING_DRIFT_BEGINS);
	return 1;
}

dcmd_enddrift(playerid, params[])
{
	#pragma unused params
	if (driftinfo[playerid][timer]==INVALID_TIMER) {
		SendClientMessage(playerid, COLOR_RED, STRING_NOT_IN_DRIFT);
		return 1;
	}
	KillTimer(driftinfo[playerid][timer]);
	driftinfo[playerid][timer] = INVALID_TIMER;
	driftinfo[playerid][drifting] = false;
	if (IsPlayerInAnyVehicle(playerid))
		RemovePlayerFromVehicle(playerid);
	new tmp[200];
	format(tmp,sizeof(tmp),STRING_DRIFT_SCORED,driftinfo[playerid][scoretotal],driftinfo[playerid][scorebest]);
	SendClientMessage(playerid, COLOR_RED, tmp);
	return 1;
}

public OnPlayerCommandText(playerid, cmdtext[])
{
	dcmd(drift,5,cmdtext);
	dcmd(enddrift,8,cmdtext);
    return 0;
}

stock CheckArea(playerid)
{
	return IsPlayerInArea(playerid,2267.8291,2347.2102,1392.8296,1513.5546);
}

drift_message(playerid, color, txt[], showtime=TIMER_TIME)
{
	new msg[256];
	switch (color) {
		case COLOR_RED: format(msg,sizeof(msg),"~r~%s",txt);
		case COLOR_GREEN: format(msg,sizeof(msg),"~g~%s",txt);
		case COLOR_LIME: format(msg,sizeof(msg),"~g~~h~%s",txt);
		case COLOR_BLUE: format(msg,sizeof(msg),"~b~%s",txt);
		case COLOR_WHITE: format(msg,sizeof(msg),"~w~%s",txt);
		case COLOR_YELLOW: format(msg,sizeof(msg),"~y~%s",txt);
		case COLOR_PINK: format(msg,sizeof(msg),"~p~%s",txt);
		case COLOR_BLACK: format(msg,sizeof(msg),"~b~%s",txt);
		default: format(msg,sizeof(msg),"%s",txt);
	}
	GameTextForPlayer(playerid, msg, showtime, 4);
}

GetVehicleMoveCharacteristics(Float:x1,Float:y1,Float:x2,Float:y2,measuretime,&Float:out_an,&Float:out_speed)
{
	new Float:dx, Float:dy, Float:distance;
    out_an = CalculateAngle2D(x1,y1,x2,y2,dx,dy);
	distance = floatsqroot(floatpower(dx,2)+
                           floatpower(dy,2));
	out_speed = floatround(distance * 5000) / measuretime;
}

public drifttimer(playerid)
{
	if (!IsPlayerInAnyVehicle(playerid)) {
		 return;
	}
	new veh,Float:x,Float:y,Float:z,Float:hp;
	veh = GetPlayerVehicleID(playerid);
	GetVehiclePos(veh,x,y,z);
	GetVehicleHealth(veh,hp);
	new Float:an,Float:sp,Float:z_angl;
	GetVehicleMoveCharacteristics(driftinfo[playerid][lastx],driftinfo[playerid][lasty],x,y,TIMER_TIME,an,sp);
	GetVehicleZAngle(veh, z_angl);
	an = an-z_angl;
	if (an>180) an = 360-an;
	if (an<-180) an = 360+an;
//	printf("an1: %f; an2: %f",an,asin(floatsin(an, degrees)));
//	an = asin(floatsin(an, degrees));
	if (!driftinfo[playerid][drifting]) {
		if (sp>2 && abs(an)>MIN_ANGLE && abs(an)<MAX_ANGLE) {
			if (sp>MIN_SPEED) {
				driftinfo[playerid][drifting] = true;
				driftinfo[playerid][score] = 0;
			} else
				drift_message(playerid, COLOR_PINK, STRING_TOO_SLOW);
		} else
			drift_message(playerid, 0, " ");
	} else {
		new Float:sc;
		sc = abs(floatsin(an, degrees))*sp;
		driftinfo[playerid][score] += floatround(sc,floatround_tozero);

		new tmp[200];
		format(tmp,sizeof(tmp), STRING_DRIFT_ONSCREEN,driftinfo[playerid][score]);
		if (hp < driftinfo[playerid][lasthealth]) {
			drift_message(playerid, COLOR_RED, tmp, 500);
			driftinfo[playerid][drifting] = false;
		} else if (abs(an)<MIN_ANGLE || abs(an)>MAX_ANGLE || sp<MIN_SPEED) {
			GivePlayerMoney(playerid,driftinfo[playerid][score] / 10);
			
			driftinfo[playerid][scoretotal] += driftinfo[playerid][score];
			driftinfo[playerid][drifting] = false;
			if (driftinfo[playerid][score]>driftinfo[playerid][scorebest]) {
				driftinfo[playerid][scorebest] = driftinfo[playerid][score];
				drift_message(playerid, COLOR_LIME, tmp, 500);
			} else {
				drift_message(playerid, COLOR_GREEN, tmp, 500);
			}
		} else {
			drift_message(playerid, COLOR_YELLOW, tmp);
		}
	}
	driftinfo[playerid][lastx] = x;
	driftinfo[playerid][lasty] = y;
	driftinfo[playerid][angle] = an;
	driftinfo[playerid][lasthealth] = hp;
}

InitDriftVehicle(playerid)
{
	new veh,Float:x,Float:y,Float:z,Float:hp;
	veh = GetPlayerVehicleID(playerid);
	GetVehiclePos(veh,x,y,z);
	driftinfo[playerid][lastx] = x;
	driftinfo[playerid][lasty] = y;
	GetVehicleHealth(veh,hp);
	driftinfo[playerid][lasthealth] = hp;
}

public OnPlayerConnect(playerid)
{
	driftinfo[playerid][timer]=INVALID_TIMER;
	driftinfo[playerid][drifting]=false;
	return 1;
}



public OnPlayerEnterVehicle(playerid, vehicleid, ispassenger)
{
	InitDriftVehicle(playerid);
	return 1;
}

public OnPlayerExitVehicle(playerid, vehicleid)
{
	if (driftinfo[playerid][timer]!=INVALID_TIMER) {
		SendClientMessage(playerid, COLOR_RED, STRING_DRIFTEND_CAREXIT);
	    dcmd_enddrift(playerid, " ");
	}
	return 1;
}

public OnPlayerStateChange(playerid, newstate, oldstate)
{
	return 1;
}

public OnPlayerEnterCheckpoint(playerid)
{
	return 1;
}

public OnPlayerLeaveCheckpoint(playerid)
{
	return 1;
}

public OnPlayerEnterRaceCheckpoint(playerid)
{
	return 1;
}

public OnPlayerLeaveRaceCheckpoint(playerid)
{
	return 1;
}

public OnRconCommand(cmd[])
{
	return 1;
}

public OnObjectMoved(objectid)
{
	return 1;
}

public OnPlayerObjectMoved(playerid, objectid)
{
	return 1;
}

public OnPlayerPickUpPickup(playerid, pickupid)
{
	return 1;
}

public OnPlayerSelectedMenuRow(playerid, row)
{
	return 1;
}

public OnPlayerExitedMenu(playerid)
{
	return 1;
}

